#!/usr/bin/env python

"""
Moin Graphviz region serialiser.

Copyright (C) 2018, 2021, 2023 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License along with
this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from moinformat.serialisers.common import Serialiser

class MoinGraphvizSerialiser(Serialiser):

    "Serialisation of the page."

    input_formats = ["graphviz", "dot"]
    formats = ["moin", "wiki"]

    def block(self, block):
        self.container(block)

    def directive(self, directive):
        if directive.directive:
            self.out("#%s\n" % directive.directive)
        else:
            self.out("//%s%s\n" % (
                directive.value and "%s=" % directive.key or directive.key,
                directive.value or ""))

    def text(self, text):
        self.out(text.s)

serialiser = MoinGraphvizSerialiser

# vim: tabstop=4 expandtab shiftwidth=4
